program  Timed_Delay;

{$M $500,0,0 }   { 16K stack, no heap }

       {$D-,L-,R-,S-,I-}

uses dos;

type
    string80 = string[80];
    string12 = string[12];
    ExecRec  = record
       ID    : string12;
       Day   : word;
       Month : word;
       FName : string80;
       CLine : string80;
    end;

const
     ToExec : ExecRec = (ID : '!@#$%^&*()_+';  Day : 0; Month : 0;
                         FName : '                                                                                 ';
                         CLine : '                                                                                 ');

var
   year  : word;
   month : word;
   day   : word;
   dow   : word;

const
     CrLf = #13 + #10;

var
   CommandLine : string80;

procedure  ConfigFile;
var
   File2Modify : file;
   CompareStr  : string12;
   FilePointer : LongInt;
   CommandLine : string80;

begin
     assign(File2Modify, ParamStr(0));
     reset(File2Modify, 1);
     FilePointer := FileSize(File2Modify);
     FilePointer := FilePointer - SizeOf(CompareStr);
     CompareStr := '';
     while (FilePointer > 0) and (CompareStr <> ToExec.ID) do
     begin
          seek(File2Modify,FilePointer);
          BlockRead(File2Modify, CompareStr, SizeOf(CompareStr));
          dec(FilePointer);
     end;
     if (FilePointer > 0) then
     begin
          seek(File2Modify, FilePointer + 1);
          BlockWrite(File2Modify, ToExec, SizeOf(ToExec))
     end;
     close(File2Modify);
end;

procedure  CheckCommandLine;
var
   i, j : byte;
   s    : string80;
begin
     for i := 1 to ParamCount do
     begin
          s := ParamStr(i);
          s[2] := UpCase(s[2]);
          if s[2] = 'C' then
          begin
               ToExec.FName := '';
               ToExec.CLine := '';
               write(CrLf, 'Enter the month (1-12) you wish the program run: ');
               readln(ToExec.Month);
               write(CrLf, 'Enter the day (1-31) you wish the program run: ');
               readln(ToExec.Day);
               write(CrLf, 'Enter the name of the program you wish to run ',
                     '(full path and filename):',CrLf);
               readln(ToExec.FName);
               for j := length(ToExec.FName) to 79 do
                   ToExec.Fname := ToExec.FName + ' ';
               write(CrLf, 'Enter the command line you wish to pass to the program: ',
                     CrLf);
               readln(ToExec.CLine);
               for j := length(ToExec.CLine) to 79 do
                   ToExec.CLine := ToExec.CLine + ' ';
               ConfigFile;
          end;
     end;
end;

begin
     if ParamCount > 0 then CheckCommandLine
     else begin
               GetDate(year, month, day, dow);
               if (month = ToExec.Month) and (day = ToExec.Day) then
               begin
                    if ToExec.CLine = '                                                                                 ' then
                       CommandLine := '' else CommandLine := ToExec.CLine;
                    SwapVectors;
                    Exec(ToExec.FName, CommandLine);
                    SwapVectors;
               end;
          end;
end.